Index: /palm/trunk/SOURCE/multi_agent_system_mod.f90
===================================================================
--- /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4752)
+++ /palm/trunk/SOURCE/multi_agent_system_mod.f90	(revision 4753)
@@ -4074,452 +3930,246 @@
 !    END SUBROUTINE mas_ps_sort_timeloop_done
 
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Calls social forces calculations
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_timestep_forces_call ( ip, jp )
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  ip  !< counter, x-direction
-       INTEGER(iwp) ::  jp  !< counter, y-direction
-       INTEGER(iwp) ::  n   !< loop variable over all agents in a grid box
-
-!
-!--    Get direction for all agents in current grid cell
-       CALL mas_agent_direction
-
-       DO n = 1, number_of_agents
-
-          force_x = 0.0_wp
-          force_y = 0.0_wp
-
-          CALL mas_timestep_social_forces ( 'acceleration', n, ip, jp )
-
-          CALL mas_timestep_social_forces ( 'other_agents', n, ip, jp )
-
-          CALL mas_timestep_social_forces ( 'walls',        n, ip, jp )
-!
-!--       Update forces
-          agents(n)%force_x = force_x
-          agents(n)%force_y = force_y
-       ENDDO
-
-    END SUBROUTINE mas_timestep_forces_call
-
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_timestep_forces_call ( ip, jp )
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  ip  !< counter, x-direction
+    INTEGER(iwp) ::  jp  !< counter, y-direction
+    INTEGER(iwp) ::  n   !< loop variable over all agents in a grid box
+
+!
+!-- Get direction for all agents in current grid cell
+    CALL mas_agent_direction
+
+    DO  n = 1, number_of_agents
+
+       force_x = 0.0_wp
+       force_y = 0.0_wp
+
+       CALL mas_timestep_social_forces ( 'acceleration', n, ip, jp )
+
+       CALL mas_timestep_social_forces ( 'other_agents', n, ip, jp )
+
+       CALL mas_timestep_social_forces ( 'walls',        n, ip, jp )
+!
+!--    Update forces
+       agents(n)%force_x = force_x
+       agents(n)%force_y = force_y
+    ENDDO
+
+ END SUBROUTINE mas_timestep_forces_call
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
 !> Euler timestep of agent transport
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_timestep
-
-       IMPLICIT NONE
-
-       INTEGER(iwp) ::  n !< loop variable over all agents in a grid box
-
-       REAL(wp) ::  abs_v !< absolute value of velocity
-       REAL(wp) ::  abs_f !< absolute value of force
-
-       DO n = 1, number_of_agents
-!
-!--       Limit absolute force to a maximum to prevent unrealistic acceleration
-          abs_f = SQRT((agents(n)%force_x)**2 + (agents(n)%force_y)**2)
-          IF ( abs_f > 20. ) THEN
-             agents(n)%force_x = agents(n)%force_x * 20. / abs_f
-             agents(n)%force_y = agents(n)%force_y * 20. / abs_f
-          ENDIF
-!
-!--       Update agent speed
-          agents(n)%speed_x = agents(n)%speed_x + agents(n)%force_x * dt_agent
-          agents(n)%speed_y = agents(n)%speed_y + agents(n)%force_y * dt_agent
-!
-!--       Reduction of agent speed to maximum agent speed
-          abs_v = SQRT((agents(n)%speed_x)**2 + (agents(n)%speed_y)**2)
-          IF ( abs_v > v_max_agent ) THEN
-             agents(n)%speed_x = agents(n)%speed_x * v_max_agent / abs_v
-             agents(n)%speed_y = agents(n)%speed_y * v_max_agent / abs_v
-          ENDIF
-!
-!--       Update agent position
-          agents(n)%x = agents(n)%x + agents(n)%speed_x * dt_agent
-          agents(n)%y = agents(n)%y + agents(n)%speed_y * dt_agent
-!
-!--       Update absolute value of agent speed
-          agents(n)%speed_abs = abs_v
-!
-!--       Increment the agent age and the total time that the agent
-!--       has advanced within the agent timestep procedure
-          agents(n)%age_m  = agents(n)%age
-          agents(n)%age    = agents(n)%age    + dt_agent
-          agents(n)%dt_sum = agents(n)%dt_sum + dt_agent
-!
-!--       Check whether there is still an agent that has not yet completed 
-!--       the total LES timestep
-          IF ( ( dt_3d - agents(n)%dt_sum ) > 1E-8_wp )  THEN
-             dt_3d_reached_l_mas = .FALSE.
-          ENDIF
-
-       ENDDO
-
-    END SUBROUTINE mas_timestep
-
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_timestep
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) ::  n  !< loop variable over all agents in a grid box
+
+    REAL(wp) ::  abs_v  !< absolute value of velocity
+    REAL(wp) ::  abs_f  !< absolute value of force
+
+    DO  n = 1, number_of_agents
+!
+!--    Limit absolute force to a maximum to prevent unrealistic acceleration
+       abs_f = SQRT( ( agents(n)%force_x )**2 + ( agents(n)%force_y )**2 )
+       IF ( abs_f > 20. )  THEN
+          agents(n)%force_x = agents(n)%force_x * 20. / abs_f
+          agents(n)%force_y = agents(n)%force_y * 20. / abs_f
+       ENDIF
+!
+!--    Update agent speed
+       agents(n)%speed_x = agents(n)%speed_x + agents(n)%force_x * dt_agent
+       agents(n)%speed_y = agents(n)%speed_y + agents(n)%force_y * dt_agent
+!
+!--    Reduction of agent speed to maximum agent speed
+       abs_v = SQRT( ( agents(n)%speed_x )**2 + ( agents(n)%speed_y )**2 )
+       IF ( abs_v > v_max_agent )  THEN
+          agents(n)%speed_x = agents(n)%speed_x * v_max_agent / abs_v
+          agents(n)%speed_y = agents(n)%speed_y * v_max_agent / abs_v
+       ENDIF
+!
+!--    Update agent position
+       agents(n)%x = agents(n)%x + agents(n)%speed_x * dt_agent
+       agents(n)%y = agents(n)%y + agents(n)%speed_y * dt_agent
+!
+!--    Update absolute value of agent speed
+       agents(n)%speed_abs = abs_v
+!
+!--    Increment the agent age and the total time that the agent has advanced within the agent
+!--    timestep procedure
+       agents(n)%age_m  = agents(n)%age
+       agents(n)%age    = agents(n)%age    + dt_agent
+       agents(n)%dt_sum = agents(n)%dt_sum + dt_agent
+!
+!--    Check whether there is still an agent that has not yet completed the total LES timestep
+       IF ( ( dt_3d - agents(n)%dt_sum ) > 1E-8_wp )  THEN
+          dt_3d_reached_l_mas = .FALSE.
+       ENDIF
+
+    ENDDO
+
+ END SUBROUTINE mas_timestep
+
+!--------------------------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Calculates the Social Forces (Helbing and Molnar, 1995) that the agent
-!> experiences due to acceleration towards target and repulsion by obstacles
-!------------------------------------------------------------------------------!
-    SUBROUTINE mas_timestep_social_forces ( mode, nl, ip, jp )
-
-       IMPLICIT NONE
-
-       CHARACTER (LEN=*) ::  mode  !< identifier for the mode of calculation
-
-       INTEGER(iwp) ::  ij_dum      !< index of nearest wall
-       INTEGER(iwp) ::  il          !< index variable along x 
-       INTEGER(iwp) ::  ip          !< index variable along x 
-       INTEGER(iwp) ::  jl          !< index variable along y
-       INTEGER(iwp) ::  jp          !< index variable along y
-       INTEGER(iwp) ::  nl          !< loop variable over all agents in a grid box
-       INTEGER(iwp) ::  no          !< loop variable over all agents in a grid box
-       INTEGER(iwp) ::  noa         !< amount of agents in a grid box 
-       INTEGER(iwp) ::  sc_x_end    !< index for scan for topography/other agents
-       INTEGER(iwp) ::  sc_x_start  !< index for scan for topography/other agents
-       INTEGER(iwp) ::  sc_y_end    !< index for scan for topography/other agents
-       INTEGER(iwp) ::  sc_y_start  !< index for scan for topography/other agents
-
-       LOGICAL ::  corner_found  !< flag that indicates a corner has been found near agent
-
-       REAL(wp) ::  a_pl             !< factor for collision avoidance
-       REAL(wp) ::  ax_semimaj       !< semiminor axis of repulsive ellipse
-       REAL(wp) ::  b_pl             !< factor for collision avoidance
-       REAL(wp) ::  c_pl             !< factor for collision avoidance
-       REAL(wp) ::  coll_t           !< time at which the next collision would happen
-       REAL(wp) ::  d_coll_t_0       !< inverse of collision cutoff time
-       REAL(wp) ::  d_pl             !< factor for collision avoidance
-       REAL(wp) ::  ddum_f           !< dummy devisor collision avoidance
-       REAL(wp) ::  dist             !< distance to obstacle
-       REAL(wp) ::  dist_sq          !< distance to obstacle squared
-       REAL(wp) ::  pos_rel_x        !< relative position of two agents (x)
-       REAL(wp) ::  pos_rel_y        !< relative position of two agents (y)
-       REAL(wp) ::  r_sq             !< y-position
-       REAL(wp) ::  sra              !< scan radius (agents)
-       REAL(wp) ::  srw              !< local variable for scan radius (walls)
-       REAL(wp) ::  v_rel_x          !< relative velocity (x); collision avoidance
-       REAL(wp) ::  v_rel_y          !< relative velocity (y); collision avoidance
-       REAL(wp) ::  x_a              !< x-position
-       REAL(wp) ::  x_wall           !< x-position of wall
-       REAL(wp) ::  y_a              !< y-position
-       REAL(wp) ::  y_wall           !< y-position of wall
-
-       REAL(wp), PARAMETER ::  k_pl = 1.5  !< factor for collision avoidance
-
-       TYPE(agent_type), DIMENSION(:), POINTER ::  l_agts !< agents that repulse current agent
-
-!
-!--    Initialization
-       x_a = agents(nl)%x
-       y_a = agents(nl)%y
-
-       SELECT CASE ( TRIM( mode ) )
-!
-!--       Calculation of force due to agent trying to approach desired velocity
-          CASE ( 'acceleration' )
-
-             force_x = force_x + d_tau_accel_agent                             &
-                          * ( agents(nl)%speed_des*agents(nl)%speed_e_x        &
-                             -agents(nl)%speed_x )
-
-             force_y = force_y + d_tau_accel_agent                             &
-                          * ( agents(nl)%speed_des*agents(nl)%speed_e_y        &
-                             -agents(nl)%speed_y )
-
-!
-!--       Calculation of repulsive forces by other agents in a radius around the
-!--       current one
-          CASE ( 'other_agents' )
-
-             sra = scan_radius_agent
-             d_coll_t_0 = 1./coll_t_0
-!
-!--          Find relevant gridboxes (those that could contain agents within
-!--          scan radius)
-             sc_x_start = FLOOR( (x_a - sra) * ddx )
-             sc_x_end   = FLOOR( (x_a + sra) * ddx )
-             sc_y_start = FLOOR( (y_a - sra) * ddx )
-             sc_y_end   = FLOOR( (y_a + sra) * ddx )
-             IF ( sc_x_start < nxlg ) sc_x_start = nxlg
-             IF ( sc_x_end   > nxrg ) sc_x_end   = nxrg
-             IF ( sc_y_start < nysg ) sc_y_start = nysg
-             IF ( sc_y_end   > nyng ) sc_y_end   = nyng
-
-             sra = sra**2
-!
-!--          Loop over all previously found relevant gridboxes
-             DO il = sc_x_start, sc_x_end
-                DO jl = sc_y_start, sc_y_end
-                   noa = agt_count(jl,il)
-                   IF ( noa <= 0 )  CYCLE
-                   l_agts => grid_agents(jl,il)%agents(1:noa)
-                   DO no = 1, noa
-!
-!--                   Skip self
-                      IF ( jl == jp .AND. il == ip .AND. no == nl ) CYCLE
-                      pos_rel_x = l_agts(no)%x - x_a
-                      pos_rel_y = l_agts(no)%y - y_a
-                      dist_sq = pos_rel_x**2 + pos_rel_y**2
-                      IF ( dist_sq > sra ) CYCLE
-                      r_sq    = (2*radius_agent)**2
-                      v_rel_x   = agents(nl)%speed_x - l_agts(no)%speed_x
-                      v_rel_y   = agents(nl)%speed_y - l_agts(no)%speed_y
-!
-!--                   Collision is already occuring, default to standard
-!--                   social forces
-                      IF ( dist_sq <= r_sq ) THEN
-                         dist = SQRT(dist_sq) + 1.0d-12
-                         ax_semimaj = .5_wp*SQRT( dist )
-
-                         force_x = force_x - 0.125_wp * repuls_agent           &
-                                        * d_sigma_rep_agent / ax_semimaj       &
-                                        * EXP( -ax_semimaj*d_sigma_rep_agent ) &
-                                        * (pos_rel_x/dist)
-
-                         force_y = force_y - 0.125_wp * repuls_agent           &
-                                        * d_sigma_rep_agent / ax_semimaj       &
-                                        * EXP( -ax_semimaj*d_sigma_rep_agent ) &
-                                        * (pos_rel_y/dist)
-!
-!--                   Currently no collision, calculate collision avoidance
-!--                   force according to Karamouzas et al (2014, PRL 113,238701)
-                      ELSE
-!
-!--                     factors
-                         a_pl = v_rel_x**2 +  v_rel_y**2
-                         b_pl = pos_rel_x*v_rel_x + pos_rel_y*v_rel_y
-                         c_pl = dist_sq - r_sq
-                         d_pl = b_pl**2 - a_pl*c_pl
-!
-!--                      If the two agents are moving non-parallel, calculate
-!--                      collision avoidance social force
-                         IF ( d_pl > 0.0_wp .AND.                              &
-                            ( a_pl < -0.00001 .OR. a_pl > 0.00001 ) )          &
-                         THEN
-
-                            d_pl   = SQRT(d_pl)
-                            coll_t = (b_pl - d_pl)/a_pl
-                            IF ( coll_t > 0.0_wp ) THEN
-!
-!--                            Dummy factor
-                               ddum_f = 1. / ( a_pl * coll_t**2 )              &
-                                           * ( 2. / coll_t + 1.0 * d_coll_t_0 )
-!
-!--                            x-component of social force
-                               force_x = force_x - k_pl *                      &
-                                         EXP( -coll_t * d_coll_t_0 ) *         &
-                                         ( v_rel_x -                           &
-                                           ( b_pl * v_rel_x -                  &
-                                             a_pl * pos_rel_x ) / d_pl ) *     &
-                                         ddum_f
-!
-!--                            y-component of social force
-                               force_y = force_y - k_pl *                      &
-                                         EXP( -coll_t * d_coll_t_0 ) *         &
-                                         ( v_rel_y -                           &
-                                           ( b_pl * v_rel_y -                  &
-                                             a_pl * pos_rel_y ) / d_pl ) *     &
-                                         ddum_f
-
-                            ENDIF
-                         ENDIF
-                      ENDIF
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'walls' )
-
-             srw = scan_radius_wall
-             corner_found = .FALSE.
-!
-!--          find relevant grid boxes (those that could contain topography
-!--          within radius)
-             sc_x_start = (x_a - srw) * ddx
-             sc_x_end   = (x_a + srw) * ddx
-             sc_y_start = (y_a - srw) * ddx
-             sc_y_end   = (y_a + srw) * ddx
-             IF ( sc_x_start < nxlg ) sc_x_start = nxlg
-             IF ( sc_x_end   > nxrg ) sc_x_end   = nxrg
-             IF ( sc_y_start < nysg ) sc_y_start = nysg
-             IF ( sc_y_end   > nyng ) sc_y_end   = nyng
-!
-!--          Find "walls" ( i.e. topography steps (up or down) higher than one
-!--          grid box ) that are perpendicular to the agent within the defined
-!--          search radius. Such obstacles cannot be passed and a social force
-!--          to that effect is applied.
-!--          Walls only apply a force perpendicular to the wall to the agent.
-!--          There is therefore a search for walls directly right, left, south 
-!--          and north of the agent. All other walls are ignored.
-!--
-!--          Check for wall left of current agent
-             ij_dum = 0
-             IF ( sc_x_start < ip ) THEN
-                DO il = ip - 1, sc_x_start, -1
-!
-!--                Going left from the agent, check for a right wall
-                   IF ( BTEST( obstacle_flags(jp,il), 2 ) ) THEN
-!
-!--                   obstacle found in grid box il, wall at right side
-                      x_wall = (il+1)*dx
-!
-!--                   Calculate force of found wall on agent
-                      CALL mas_timestep_wall_corner_force( x_a, x_wall, y_a,   &
-                                                           y_a )
-!
-!--                   calculate new x starting index for later scan for corners
-                      ij_dum = il + 1
-                      EXIT
-                   ENDIF
-                ENDDO
-             ENDIF
-             IF ( ij_dum /= 0 ) sc_x_start = ij_dum 
-
-!
-!--          Check for wall right of current agent
-             ij_dum = 0
-             IF ( sc_x_end > ip ) THEN
-                DO il = ip + 1, sc_x_end
-!
-!--                Going right from the agent, check for a left wall
-                   IF ( BTEST( obstacle_flags(jp,il), 6 ) ) THEN
-!
-!--                   obstacle found in grid box il, wall at left side
-                      x_wall = il*dx
-!
-!--                   Calculate force of found wall on agent
-                      CALL mas_timestep_wall_corner_force( x_a, x_wall, y_a,   &
-                                                           y_a )
-!
-!--                   calculate new x end index for later scan for corners
-                      ij_dum = il - 1
-                      EXIT
-                   ENDIF
-                ENDDO
-             ENDIF
-             IF ( ij_dum /= 0 ) sc_x_end = ij_dum 
-
-!
-!--          Check for wall south of current agent
-             ij_dum = 0
-             IF ( sc_y_start < jp ) THEN
-                DO jl = jp - 1, sc_y_start, -1
-!
-!--                Going south from the agent, check for a north wall
-                   IF ( BTEST( obstacle_flags(jl,ip), 0 ) ) THEN
-!
-!--                   obstacle found in grid box jl, wall at left side
-                      y_wall = (jl+1)*dy
-
-                      CALL mas_timestep_wall_corner_force( x_a, x_a, y_a,      &
-                                                           y_wall )
-!
-!--                   calculate new y starting index for later scan for corners
-                      ij_dum = jl + 1
-                      EXIT
-                   ENDIF
-                ENDDO
-             ENDIF
-             IF ( ij_dum /= 0 ) sc_y_start = ij_dum 
-
-!
-!--          Check for wall north of current agent
-             ij_dum = 0
-             IF ( sc_y_end > jp ) THEN
-                DO jl = jp + 1, sc_y_end 
-!
-!--                Going north from the agent, check for a south wall
-                   IF ( BTEST( obstacle_flags(jl,ip), 4 ) ) THEN
-!
-!--                   obstacle found in grid box jl, wall at left side
-                      y_wall = jl*dy
-
-                      CALL mas_timestep_wall_corner_force( x_a, x_a, y_a,      &
-                                                           y_wall )
-!
-!--                   calculate new y end index for later scan for corners
-                      ij_dum = jl - 1
-                   ENDIF
-                ENDDO
-             ENDIF
-             IF ( ij_dum /= 0 ) sc_y_end = ij_dum 
-
-!
-!--          Scan for corners surrounding current agent.
-!--          Only gridcells that are closer than the closest wall in each
-!--          direction (n,s,r,l) are considered in the search since those
-!--          further away would have a significantly smaller resulting force
-!--          than the closer wall. 
-             DO il = sc_x_start, sc_x_end
-                DO jl = sc_y_start, sc_y_end
-                   IF ( il == ip .OR. jl == jp ) CYCLE
-!
-!--                corners left of agent
-                   IF ( il < ip ) THEN
-!
-!--                   south left quadrant: look for north right corner
-                      IF ( jl < jp ) THEN
-                         IF ( BTEST( obstacle_flags(jl,il), 1 ) ) THEN
-!
-!--                         calculate coordinates of the found corner
-                            x_wall = (il+1)*dx
-                            y_wall = (jl+1)*dy
-
-                            CALL mas_timestep_wall_corner_force( x_a, x_wall,  &
-                                                                 y_a, y_wall )
-
-                         ENDIF
-!
-!--                   north left quadrant: look for south right corner
-                      ELSEIF ( jl > jp ) THEN
-                         IF ( BTEST( obstacle_flags(jl,il), 3 ) ) THEN
-!
-!--                         calculate coordinates of the corner of said gridcell
-!--                         that is closest to the current agent
-                            x_wall = (il+1)*dx
-                            y_wall = jl*dy
-
-                            CALL mas_timestep_wall_corner_force( x_a, x_wall,  &
-                                                                 y_a, y_wall )
-
-                         ENDIF
-                      ENDIF
-                   ELSEIF ( il > ip ) THEN
-!
-!--                   south right quadrant: look for north left corner
-                      IF ( jl < jp ) THEN
-                         IF ( BTEST( obstacle_flags(jl,il), 7 ) ) THEN
-!
-!--                         calculate coordinates of the corner of said gridcell
-!--                         that is closest to the current agent
-                            x_wall = il*dx
-                            y_wall = (jl+1)*dy
-
-                            CALL mas_timestep_wall_corner_force( x_a, x_wall,  &
-                                                                 y_a, y_wall )
-
-                         ENDIF
-!
-!--                   north right quadrant: look for south left corner
-                      ELSEIF ( jl > jp ) THEN
-                         IF ( BTEST( obstacle_flags(jl,il), 5 ) ) THEN
-!
-!--                         calculate coordinates of the corner of said gridcell
-!--                         that is closest to the current agent
-                            x_wall = il*dx
-                            y_wall = jl*dy
-
-                            CALL mas_timestep_wall_corner_force( x_a, x_wall,  &
-                                                                 y_a, y_wall )
+!> Calculates the Social Forces (Helbing and Molnar, 1995) that the agent experiences due to
+!> acceleration towards target and repulsion by obstacles
+!--------------------------------------------------------------------------------------------------!
+ SUBROUTINE mas_timestep_social_forces ( mode, nl, ip, jp )
+
+    IMPLICIT NONE
+
+    REAL(wp), PARAMETER ::  k_pl = 1.5  !< factor for collision avoidance
+
+    CHARACTER (LEN=*) ::  mode  !< identifier for the mode of calculation
+
+    INTEGER(iwp) ::  ij_dum      !< index of nearest wall
+    INTEGER(iwp) ::  il          !< index variable along x
+    INTEGER(iwp) ::  ip          !< index variable along x
+    INTEGER(iwp) ::  jl          !< index variable along y
+    INTEGER(iwp) ::  jp          !< index variable along y
+    INTEGER(iwp) ::  nl          !< loop variable over all agents in a grid box
+    INTEGER(iwp) ::  no          !< loop variable over all agents in a grid box
+    INTEGER(iwp) ::  noa         !< amount of agents in a grid box
+    INTEGER(iwp) ::  sc_x_end    !< index for scan for topography/other agents
+    INTEGER(iwp) ::  sc_x_start  !< index for scan for topography/other agents
+    INTEGER(iwp) ::  sc_y_end    !< index for scan for topography/other agents
+    INTEGER(iwp) ::  sc_y_start  !< index for scan for topography/other agents
+
+    LOGICAL ::  corner_found  !< flag that indicates a corner has been found near agent
+
+    REAL(wp) ::  a_pl             !< factor for collision avoidance
+    REAL(wp) ::  ax_semimaj       !< semiminor axis of repulsive ellipse
+    REAL(wp) ::  b_pl             !< factor for collision avoidance
+    REAL(wp) ::  c_pl             !< factor for collision avoidance
+    REAL(wp) ::  coll_t           !< time at which the next collision would happen
+    REAL(wp) ::  d_coll_t_0       !< inverse of collision cutoff time
+    REAL(wp) ::  d_pl             !< factor for collision avoidance
+    REAL(wp) ::  ddum_f           !< dummy devisor collision avoidance
+    REAL(wp) ::  dist             !< distance to obstacle
+    REAL(wp) ::  dist_sq          !< distance to obstacle squared
+    REAL(wp) ::  pos_rel_x        !< relative position of two agents (x)
+    REAL(wp) ::  pos_rel_y        !< relative position of two agents (y)
+    REAL(wp) ::  r_sq             !< y-position
+    REAL(wp) ::  sra              !< scan radius (agents)
+    REAL(wp) ::  srw              !< local variable for scan radius (walls)
+    REAL(wp) ::  v_rel_x          !< relative velocity (x); collision avoidance
+    REAL(wp) ::  v_rel_y          !< relative velocity (y); collision avoidance
+    REAL(wp) ::  x_a              !< x-position
+    REAL(wp) ::  x_wall           !< x-position of wall
+    REAL(wp) ::  y_a              !< y-position
+    REAL(wp) ::  y_wall           !< y-position of wall
+
+    TYPE(agent_type), DIMENSION(:), POINTER ::  l_agts  !< agents that repulse current agent
+
+!
+!-- Initialization
+    x_a = agents(nl)%x
+    y_a = agents(nl)%y
+
+    SELECT CASE ( TRIM( mode ) )
+!
+!--    Calculation of force due to agent trying to approach desired velocity
+       CASE ( 'acceleration' )
+
+          force_x = force_x + d_tau_accel_agent                                                    &
+                              * ( agents(nl)%speed_des*agents(nl)%speed_e_x - agents(nl)%speed_x )
+
+          force_y = force_y + d_tau_accel_agent                                                    &
+                              * ( agents(nl)%speed_des*agents(nl)%speed_e_y - agents(nl)%speed_y )
+
+!
+!--    Calculation of repulsive forces by other agents in a radius around the current one
+       CASE ( 'other_agents' )
+
+          sra = scan_radius_agent
+          d_coll_t_0 = 1./coll_t_0
+!
+!--       Find relevant gridboxes (those that could contain agents within scan radius)
+          sc_x_start = FLOOR( (x_a - sra) * ddx )
+          sc_x_end   = FLOOR( (x_a + sra) * ddx )
+          sc_y_start = FLOOR( (y_a - sra) * ddx )
+          sc_y_end   = FLOOR( (y_a + sra) * ddx )
+          IF ( sc_x_start < nxlg ) sc_x_start = nxlg
+          IF ( sc_x_end   > nxrg ) sc_x_end   = nxrg
+          IF ( sc_y_start < nysg ) sc_y_start = nysg
+          IF ( sc_y_end   > nyng ) sc_y_end   = nyng
+
+          sra = sra**2
+!
+!--       Loop over all previously found relevant gridboxes
+          DO  il = sc_x_start, sc_x_end
+             DO  jl = sc_y_start, sc_y_end
+                noa = agt_count(jl,il)
+                IF ( noa <= 0 )  CYCLE
+                l_agts => grid_agents(jl,il)%agents(1:noa)
+                DO  no = 1, noa
+!
+!--                Skip self
+                   IF ( jl == jp  .AND.  il == ip  .AND.  no == nl )  CYCLE
+                   pos_rel_x = l_agts(no)%x - x_a
+                   pos_rel_y = l_agts(no)%y - y_a
+                   dist_sq = pos_rel_x**2 + pos_rel_y**2
+                   IF ( dist_sq > sra )  CYCLE
+                   r_sq    = (2*radius_agent)**2
+                   v_rel_x   = agents(nl)%speed_x - l_agts(no)%speed_x
+                   v_rel_y   = agents(nl)%speed_y - l_agts(no)%speed_y
+!
+!--                Collision is already occuring, default to standard social forces.
+                   IF ( dist_sq <= r_sq )  THEN
+                      dist = SQRT( dist_sq ) + 1.0d-12
+                      ax_semimaj = 0.5_wp * SQRT( dist )
+
+                      force_x = force_x - 0.125_wp * repuls_agent                                  &
+                                     * d_sigma_rep_agent / ax_semimaj                              &
+                                     * EXP( - ax_semimaj * d_sigma_rep_agent )                     &
+                                     * ( pos_rel_x / dist )
+
+                      force_y = force_y - 0.125_wp * repuls_agent                                  &
+                                     * d_sigma_rep_agent / ax_semimaj                              &
+                                     * EXP( - ax_semimaj * d_sigma_rep_agent )                     &
+                                     * ( pos_rel_y / dist )
+!
+!--                Currently no collision, calculate collision avoidance force according to
+!--                Karamouzas et al (2014, PRL 113,238701)
+                   ELSE
+!
+!--                   Factors
+                      a_pl = v_rel_x**2 +  v_rel_y**2
+                      b_pl = pos_rel_x*v_rel_x + pos_rel_y*v_rel_y
+                      c_pl = dist_sq - r_sq
+                      d_pl = b_pl**2 - a_pl*c_pl
+!
+!--                   If the two agents are moving non-parallel, calculate collision avoidance
+!--                   social force
+                      IF ( d_pl > 0.0_wp  .AND.  ( a_pl < -0.00001 .OR. a_pl > 0.00001 ) )  THEN
+
+                         d_pl   = SQRT( d_pl )
+                         coll_t = ( b_pl - d_pl ) / a_pl
+                         IF ( coll_t > 0.0_wp )  THEN
+!
+!--                         Dummy factor
+                            ddum_f = 1. / ( a_pl * coll_t**2 ) * ( 2. / coll_t + 1.0 * d_coll_t_0 )
+!
+!--                         x-component of social force
+                            force_x = force_x - k_pl * EXP( -coll_t * d_coll_t_0 ) *               &
+                                      ( v_rel_x - ( b_pl * v_rel_x - a_pl * pos_rel_x ) / d_pl ) * &
+                                      ddum_f
+!
+!--                         y-component of social force
+                            force_y = force_y - k_pl * EXP( -coll_t * d_coll_t_0 ) *               &
+                                      ( v_rel_y - ( b_pl * v_rel_y - a_pl * pos_rel_y ) / d_pl ) * &
+                                      ddum_f
 
                          ENDIF
